

;-----------------------------------------------------------------------------
;
;     W A V E
;
;  - d a w n 2 - 
;
; Started 31.10.1997 by Tim Bscke
;
;       31.10   - initial setup
;       01.11   - screen handling,init
;       02.11   - tile renderer, finished init
;       08.11   - started soundcode
;      -25.12   - muchmuch more..
;
; This code may NOT contain any direct addressing !!
;
; fastmem hunk is given in a4
; chipmem hunk is given in a5
;-----------------------------------------------------------------------------

waitras MACRO
.agend
        move.l  $dff004,d0
        and.l   #$0001ff00,d0
        cmp.l   #$0004000,d0
        bne.s   .agend
        ENDM
setcol  MACRO
        move    #$02,$dff106
        move    #\1,$dff180
        ENDM
        
testheader:

;       movem.l d0-a6,-(a7)
        lea     chip,a5
        lea     b,a4
        jsr     main
;       movem.l (a7)+,d0-a6
        moveq   #0,d0
        rts

        section blabla,bss_c
chip:
        ds.b    1024*256

        section main,code

;----------------------------- MAIN --------------------------  
a
main:   
        lea     bitplaneptr(pc),a4
        move.l  a5,(a4)+
        
        move.l  4.w,a6
        lea     GFXNAME(pc),a1          
        moveq   #33,d0
        jsr     -552(a6)        ;open gfxlib    
        move.l  d0,-(a7)        ;gfxbase!!
        move.l  d0,a6
        move.l  34(a6),-(a7)    ;activeview     
        sub.l   a1,a1
        jsr     -222(a6)        ;loadview(NULL) hell..this only works w. a6
        move.l  4.w,a6
        jsr     -132(a6)        ;forbid

;------------------------------------------
;Init Copperlist
;------------------------------------------

        move.w  #$2000,d0       ;bitplane size  
        lea     (a5,d0.w*8),a1  ;a3=copperlist dest

        lea     $dff000,a6      ;a6=regbase !!!

        lea     copperlist(pc),a0
        moveq   #(coplistend-copperlist)/4-1,d7
.clop1
        move.l  (a0)+,(a1)+
        dbf     d7,.clop1       

;------------------------------------------
;Set bitplane pointers
;------------------------------------------

        move    #$e0,d2         
.op1
        move.l  a5,d1
        add.w   d0,a5
.kll    move    d2,(a1)+
        swap    d1
        move    d1,(a1)+
        addq    #2,d2
        move    d2,d3
        lsr     #2,d3
        bcs.s   .kll    
        lsr     #7,d3
        bcc.s   .op1            
                        ; end copperlist
        moveq   #-2,d0
        move.l  d0,(a1)+
h
        move.l  a5,$80(a6)      ;set copperlist

;------------------------------------------
;get vbr and init irq 
;------------------------------------------

        move.l  $4.w,a3
        moveq   #2,d1
        lea     VBX(pc),a5
        jsr     -30(a3)         ;SuperVisor

        move.w  $1c(a6),d0
        or.w    #$8000,d0
        move.w  d0,-(a7)        
        move.w  #$7fff,$9a(a6)  
        or.w    #$4020,d0
        move.w  d0,$9a(a6)      ;set VBL irq
        move.l  $6c(a3),-(a7)   
        move.l  a3,-(a7)
        lea     irq(pc),a0
        move.l  a0,$6c(a3)

        move.l  a7,(a4)+;save sp
;       move.l  a1,(a4)+;chipend
;---------------------------------------------
;create sintab 34 bytes, d7 contains $0000ffff
;---------------------------------------------
        lea     Sin1024(pc),a0
        
        moveq   #0,d0          ;a=0
        move.l  #12500000,d1   ;b=d
       
;        move    #2047,d7

        lsr.w   #5,d7        ;2048 values
.slop1
        move.l  d0,(a0)+       ;store a 
        move.l  d0,d2           
        muls.l  #-161708,d3:d2 ;a*d^2
        add.l   d1,d0          ;a'=a+b  
        add.l   d3,d1          ;b'=b+a*d^2      
        dbf     d7,.slop1
        
;------------------------------------------
;calculate textures     d7 always $10000 for bd 
;                       adressing !!
;------------------------------------------

        addq.l  #1,d7
        add.l   #text_stone-ringbuffer,a4
        move.l  a4,a0           

        moveq   #-1,d6
.tlop1
        rol.l   d0,d0
        addq.l  #3,d0
        move.b  d0,(a0)+
        dbf     d6,.tlop1
                                ;a0 pointing to next texture !!

; Blur texture, 54 bytes

        moveq   #5,D2

        move.l  a4,a0
        moveq   #64,d3
        lsl.l   #2,d3   ;256    0x00000100
        move.l  d3,d0
        neg.w   d0      ;-256.w 0x0000ff00
        moveq   #0,D5
.tlop4
        move.l  a0,a1
.tlop3
        moveq   #0,D4
        move.b  (a0,d0.l),D4
        move.b  (a1)+,d5
        add     d5,d4
        move.b  (a1),d5
        add     d5,d4
        move.b  (a0,d3.l),D5

        addq.w  #1,d0
        add     d5,d4
        addq.w  #1,d3
        lsr     #2,d4           
        move.b  d4,(a1)
        dbf     D6,.tlop3
        move.b  d4,(a0)
        dbf     D2,.tlop4

        lea     (a4,d7.l*2),a0
.tlop2
        moveq   #127,d1
        move.b  (a4),d0
        lsl.b   #2,d0   
        bpl.w   .nore
        eor     d1,d0
.nore
        move.b  d0,(a4)+
        and.b   d1,d0   
        move.b  d0,(a0)+
        
        dbf     d6,.tlop2

;------------------------------------------
;Main
;------------------------------------------
        lea     $dff000,a6


        moveq   #0,d0
        moveq   #6,d1

mainloop:
        bsr.w   .clr
.do1    
        bsr     rain
        bsr     screenupdate
        cmp.w   #180,d0
        blt.s   .do1

;       bsr.s   .clr
.do2    
        bsr     rain
        bsr     title
        bsr     screenupdate
        cmp.w   #360,d0
        blt.s   .do2

        moveq   #12,d0
        moveq   #6,d1


        bsr.s   .clr
.do3
        bsr     feedback
        bsr     screenupdate
        cmp.w   #800,d0
        blt.s   .do3

        moveq   #0,d0
        moveq   #18,d1

        bsr.s   .clr
.do4
        bsr     tunnel
        bsr     screenupdate
        cmp.w   #800,d0
        blt.s   .do4


        moveq   #6,d0
        moveq   #18,d1

        bsr.s   .clr
.do5
        bsr     circdist
        bsr     screenupdate
        cmp.w   #800,d0
        blt.s   .do5


        moveq   #0,d0
        moveq   #12,d1

        bsr.s   .clr
.do6
        bsr     cleanbuf
        bsr     plane
        bsr     lochtunnel
        bsr     screenupdate
        cmp.w   #800,d0
        blt.s   .do6

        moveq   #0,d0
        moveq   #6,d1
        bsr.s   .clr
.end
        bsr     rain
        bsr     title
        bsr     screenupdate
        bra.s   .end    
.clr
        lea     globalcount(pc),a0
        clr.l   (a0)
        bra.w   newcolors

;------------------------------------------
;Supervisor mode code
;------------------------------------------

VBX     movec   vbr,a3
        rte

;------------------------------------------
;Irq-Routine
;------------------------------------------

irq:
        movem.l d0-a6,-(a7)
;call custom

;------------------------------------------
;Sound synthesis
;------------------------------------------
.agend
        lea     blr(pc),a0
        add     #30,(a0)
        lea     globalcount(pc),a0
        addq.l  #1,(a0)

;------------------------------------------
;Finish IRQ
;------------------------------------------
        moveq   #$20,d0
        lea     $dff09c,a0
        move    d0,(a0)
        move    d0,(a0)
        movem.l (a7)+,d0-a6
        rte

;-------- screenhandler -----------------------------

;---------------------------------------------------------------------------
; 4 pass (3cpu 1blitter) linear 256 color C2P
;
;(C) 30.5.1996 Azure/Artwork
;
;
;IN:
;
;       a0   =source
;       a1   =target
;       d0.l =number of bytes
;
;----------------------------------------------------------------------------

                
;MERGE          d1,d2,tmp,mask,shift

MERGE           MACRO   

                move.l   \2,\3
                lsr.l   #\5,\3
                eor.l    \1,\3
                and.l    \4,\3
                eor.l    \3,\1
                lsl.l   #\5,\3
                eor.l    \3,\2
                ENDM

MERGE1          MACRO   

                move.l   \2,\3
                lsr.l    #1,\3
                eor.l    \1,\3
                and.l    \4,\3
                eor.l    \3,\1
                add.l    \3,\3
                eor.l    \3,\2
                ENDM
                
MERGEw          MACRO
                swap    \2
                eor.w   \1,\2
                eor.w   \2,\1
                eor.w   \1,\2
                swap    \2
                ENDM
                
;------------------------------------------
;Screenhandling: A0=pointer to chunky buffer
;------------------------------------------

screenupdate:
                lea     chunky(pc),a0
                movem.l d0-a6,-(a7)
                lea     bitplaneptr(pc),a3
                move.l  (a3)+,a1
                btst    #6,$bfe001
                bne.s   .continue
                
;------------------------------------------
;Reinitialise the OS (quit)
;------------------------------------------
                move.l  (a3),a7         ;restore sp
                move.l  (a7)+,a3        ;vbr
                move.l  (a7)+,$6c(a3)
        
                move    #$7fff,$9a(a6)  ;irqflags
                move.w  (a7)+,$9a(a6)   ;restore

                move.l  (a7)+,a1        ;activeview     
                move.l  (a7)+,a6        ;gfxbase
                move.l  38(a6),$dff080  ;coplist
                jsr     -222(a6)        ;loadview

                move.l  a6,a1
                move.l  4.w,a6
                jsr     -414(a6)        ;closelib
                jsr     -138(a6)        ;permit
                rts                     ;quit
.continue               

.screensize=256*256
.plane=.screensize/8

                move.l  a7,8(a3)
                
                move.l  a0,a7
                add.l   #.screensize,a7
                subq.l  #4,a1
.loop
;  16x4
;  8 x2
;  4 x1
;  2 x4
;  1 x2 
                move.l  (a0),d0
                move.l  2*4+0(a0),d2
                move.l  4*4+0(a0),d4
                move.l  6*4+0(a0),d6

                move.l  d5,.plane(a1)   ;  Plane 1

                MERGEw  d0,d4
                exg     d0,d2
                exg     d4,d6

                MERGEw  d0,d4
                exg     d0,d2
                exg     d4,d6
                
                MERGE   d0,d2,d3,#$00FF00FF,8
                exg     d0,d4
                exg     d2,d6
                MERGE   d0,d2,d3,#$00FF00FF,8
                exg     d0,d4
                exg     d2,d6
                
                move.l  1*4(a0),d1
                move.l  3*4(a0),d3
                move.l  5*4(a0),d5
                move.l  7*4(a0),d7

                add.w   #32,a0
                
                move.l  a6,(a1)         ;  Plane 0
                move.l  d4,a6           ;  d3->a6

                MERGEw  d1,d5
                exg     d1,d3
                exg     d5,d7

                MERGEw  d1,d5
                exg     d1,d3
                exg     d5,d7

                add.w   #(.screensize/4)*1,a1
                
                move.l  a3,.plane(a1)   ;       3
                MERGE   d5,d7,d4,#$00FF00FF,8
                exg     d5,d1
                exg     d7,d3
                MERGE   d5,d7,d4,#$00FF00FF,8
                exg     d5,d1
                exg     d7,d3

                MERGE   d0,d1,d4,#$0F0F0F0F,4
                exg     d0,d2
                exg     d1,d3
                MERGE   d0,d1,d4,#$0F0F0F0F,4
                exg     d0,d2
                exg     d1,d3

                move.l  a2,(a1)         ;       2

                MERGE   d6,d7,d4,#$0F0F0F0F,4
                exg.l   d1,d6
                exg.l   d7,d5

                exg.l   d6,a6           ;d4-> a6
                MERGE   d6,d7,d4,#$0F0F0F0F,4
                exg.l   d1,d6
                exg.l   d7,d5
                

                add.w   #(.screensize/4)*1,a1
                move.l  a5,.plane(a1)   ;       5       
                MERGE   d0,d1,d4,#$33333333,2
                exg     d0,d2
                exg     d1,d6
                MERGE   d0,d1,d4,#$33333333,2
                exg     d0,d2
                exg     d1,d6

                move.l  a4,(a1)         ;       4
                add.w   #(.screensize/4)*1+4,a1

                exg.l   d1,a6           ;d4=a6

                MERGE   d3,d7,d4,#$33333333,2
                exg     d3,d1
                exg     d7,d5
                MERGE1  d0,d2,d4,#$55555555
                exg     d2,d6
                
                move.l  d0,.plane(a1)   ;->Plane 7      
                move.l  a6,d0

                MERGE   d3,d7,d4,#$33333333,2
                exg     d3,d1
                exg     d7,d5

                MERGE1  d0,d2,d4,#$55555555
                exg     d2,d6
                
                move.l  d0,a5
                MERGE1  d1,d3,d4,#$55555555
                exg     d1,d5
                exg     d3,d7

                move.l  d2,(a1)
                move.l  d6,a4
                move.l  d5,a3

                sub.l   #(.screensize/4)*3,a1
                
                MERGE1  d1,d3,d4,#$55555555
                exg     d1,d5
                
                move.l  d3,a6
                move.l  d7,a2

                cmp.l   a7,a0
                blt.w   .loop
endc2p
                move.l  a7save(pc),a7
                movem.l (a7)+,d0-a6
                move.l  globalcount(pc),d0
                rts

;-------- Resistent Data ----------------------------

GFXNAME:        dc.b    "graphics.library"      ;The terminating 0
                                                ;is at the beginning of 
                                                ;the coplist !! 
Copperlist:
        dc.w $0092,$48
        dc.w $0096,$20
        dc.w $0100,$0211
        dc.w $0102,$8800
        dc.w $01fc,3
        dc.w $0104,$027f
        dc.w $0108,0
        dc.w $010a,0
        dc.w $0094,$a8 
        dc.w $008e,$2a81
        dc.w $0090,$29a3
coplistend:


;-------- Subroutines ------------------------------- 

;------------------------------------------
;calccolors palette
;d0=colortable offset for 000-127
;d1=colortable offset for 128-255
;------------------------------------------

cols:
        dc.w    255,255,100     ;gelb
        dc.w    255,100,100     ;rot
        dc.w    200,100,255     ;violett
        dc.w    255,200,150     ;brunlich

colsub:
        move    #127,d7
        moveq   #0,d2
.lop1
        add     #$1ff,d2
        movem.w cols(pc,d0.w),d3/d4/d5  ;rgb mutliplier 
        mulu    d2,d3
        mulu    d2,d4
        mulu    d2,d5
        swap    d5
        lsr.l   #8,d4
        move    d4,d3
        move.b  d5,d3
        move.l  d3,(a0)+
        dbf     d7,.lop1        

        rts

newcolors:

        lea     palette(pc),a0
        move.l  a0,a1
        bsr.b   colsub
        move.l  d1,d0
        bsr.b   colsub
        
;------------------------------------------
;Set palette input : a1= pointer to palette
;------------------------------------------

setpalette:

        moveq   #0,d4
.lop1
        move.l  d4,d0
;------------------- SETCHUNKYCOL -----------------------------------------
;D0.w=Register
;D1.w=Farbe 00RrGgBb
;d2-d3=scratch
;A6=$dff000
.setchcol:
        
        move    d0,d3           
        and     #%00011111,d0   
        and     #%11100000,d3   
        lsl     #8,d3           

        or      #%11000000,d0
        or      #%00000010,d3

        move.l  (a1),d1
        lsr.l   #4,d1
        lsl.b   #4,d1   
        lsl.w   #4,d1   
        lsr.l   #8,d1   
        move    d3,$106(a6)
        move.w  d1,(a6,d0.w*2)  

        or      #$200,d3

        move.l  (a1)+,d1
        
        lsl.b   #4,d1   
        lsl.w   #4,d1
        lsr.l   #8,d1
        move    d3,$106(a6)
        move.w  d1,(a6,d0.w*2)

        addq.b  #1,d4
        bne.s   .lop1
        rts

;------------------------------------------
;Render Tiles Shaped
;
;eats:  d0.l=texturenumber (1-x)
;       tiles_current current tiles (33*33)
;------------------------------------------

Rendertilesshape:
se
        move.l  d0,-(a7)
        move.l  (a7)+,d0
        swap    d0

        move.l  a6,-(a7)

        lea     chunky(pc),a0           ;a0=chunkydest
        lea     current_tiles(pc),a1    ;a1=tiles
        move.l  a1,a6
        lea     (a0,d0.l),a2            ;a2=texture

;regused
;
;d0 d1 d2 d4 d5 d7
;
;a0 a1 a2 a3 a4 a5 a6
;
;free
;
;d3 d6
;
;a2 (a6) ((((a7))))

        moveq   #32-1,d7
.bylop
        swap    d7
        move    #32-1,d7
.bxlop
        move.l  d7,-(a7)
        
        move.l  (a1)+,d0                ;ol ,  UUUUVVVV
        move.l  (a1)+,d1                ;      rrrrbbbb
        move.l  (a1),a5                 ;or
        move.l  4(a1),a4
        sub.l   d0,a5
        move.l  a4,d5
        sub.l   d1,a4
        and.l   d1,d5
        movem.l 8*33-8(a1),d2/d3/d4/d6  ;ul/ur
                                        ;d2 d3
                                        ;d4 d6

                                        ;d0 d1
                                        ;a5 a4
        and.l   d3,d5                                   
        sub.l   d2,d4
        and.l   d6,d5
        bmi.w   .nodraw
        sub.l   a5,d4                   
                                        ;a3 = xdeltadelta for y (8.8)
                                        ;a5 = xdeltastart
                                        
        sub.l   d0,d2
        sub.l   d3,d6

        sub.l   d1,d3
        move.l  d2,-12(a6)               
        sub.l   a4,d6                   
        move.l  d3,-4(a6)               ;<---- 

        asr.l   #3,d4
        asr.l   #3,d6
        lsl.w   #3,d4
        lsl.w   #3,d6
        asr.w   #3,d4                   ;some 060 pairing
        asr.w   #3,d6                   ;some 060 pairing
        move.l  d4,a3   
        move.l  d6,-8(a6)               ;<----                  

        lsl.l   #3,d0
        lsl.l   #3,d1
                                        ;d1 = start r/b 

;       add.l   #$80008000,d0
        moveq   #0,d5
        moveq   #7,d7
.xlop
        move.l  d0,d4
        move.l  d1,d6
        
        rept    8
        bmi.s   *+14    ;branch to here
        move.w  d4,d5 
        rol.l   #8,d4  
        move.b  d4,d5  
        ror.l   #8,d4  
        move.b  (a2,d5.l),(a0)          ;fucker... 
;here
        add.l   a5,d4
        add.l   a4,d6 
        addq    #1,a0
        endr
        
        add.l   -12(a6),d0              ;start
        add.l   a3,a5           ;adder
        add.l   -4(a6),d1       ;start
        add.w   #256-8,a0
        add.l   -8(a6),a4       ;adder
        dbf     d7,.xlop

        sub.w   #256*8,a0
.nodraw
        addq.l  #8,a0
        move.l  (a7)+,d7
        dbf     d7,.bxlop       
        add.w   #256*7,a0
        addq.l  #8,a1
        swap    d7
        dbf     d7,.bylop

        move.l  (a7)+,a6
sd
        rts     

;----------------
;in:
;
;keylist a1.w
;vallist! a0
;trashed a0,a1,d0-d5
;
;pos in globalpos
;----------------

findkey:
        movem.l d1-a6,-(a7)

        moveq   #0,d0
        move.l  globalcount(pc),d5

.again
        move.w  (a1)+,d4
        cmp     d5,d4
        bpl.s   .keyfound
        move.w  d4,d0
        addq    #1,a0
        bra.s   .again
.keyfound               
        sub.w   d0,d4   ;framelength
        beq.s   .zero   
        sub.w   d0,d5   ;pos in frame
        mulu.w  #256,d5
        divu.w  d4,d5   ;d4=t
        move    d5,d4
.zero           

;------------------------------------------
;hermite spline routine
;------------------------------------------

;  d5      trashed
;  d4      t
;  d3      c0=-  ( p1 - 3  *p2 + 3  *p3 - p4);
;  d2      c1= 2  *p1 - 5  *p2 + 4  *p3 - p4;
;  d1      c2=-    p1          +     p3;
;  d0      c3=          2  *p2;
;

hermite:
        moveq   #0,d0
        moveq   #0,d1
        moveq   #0,d2
        moveq   #0,d3   ;maybe movem from some empty section.. 

        move.b  (a0)+,d2        ;p1
        move.b  (a0)+,d0        ;p2 
        move.b  (a0)+,d1        ;p3
        move.b  (a0)+,d3        ;p4

; coeff matrix , 28 bytes

        move.l  d1,d5           ;d5 = p3
        sub.l   d2,d1           ;d1 = -p1 + p3 = c2 fin
        
        add.l   d5,d5           ;d5 = 2 *p3
        add.l   d5,d2           ;d2 = 1 *p1 + 2 *p3
        add.l   d2,d2           ;d2 = 2 *p1 + 4 *p3

        sub.l   d3,d2           ;d2 = 2 *p1 + 4 *p3 - p4
                                ;d3 = dead
        sub.l   d0,d2           ;d2 = 2 *p1 -    p2 + 4 *p3 - p4
        add.l   d0,d0           ;d0 = 2 *p2 fin
        sub.l   d0,d2           ;d2 = 2 *p1 - 3 *p2 + 4 *p3 - p4
        move.l  d2,d3
        add.l   d1,d3           ;d3 =    p1 - 3 *p2 + 5 *p3 - p4
        sub.l   d5,d3           ;d3 =    p1 - 3 *p2 + 3 *p3 - p4
        neg.l   d3              ;d3 =- ( p1 - 3 *p2 + 3 *p3 - p4) = c0 fin
        sub.l   d0,d2           ;d2 = 2 *p1 - 5 *p2 + 4 *p3 - p4  = c1 fin

;       d0 c3
;       d1 c2
;       d2 c1
;       d3 c0
;       d4 t

        move.l  d4,d5
        lsl.l   #8,d0   ;c3
        muls.w  d4,d1   ;c0*t
        add.l   d1,d0
        mulu.w  d4,d4   ;t*t
        lsr.l   #8,d4
        muls.w  d4,d2   ;c1*t*t
        add.l   d2,d0
        mulu.w  d5,d4   ;t*t*t 
        lsr.l   #8,d4
        muls.w  d4,d3   ;c2*t*t*t
        add.l   d3,d0
        asr.l   #1,d0   ;26 bytes

        movem.l (a7)+,d1-a6
;               d0=x.8 contains output
        rts
        
;------------------------------------------
;circledistort (cacool=0 is 96 bytes)
;------------------------------------------

cacool=0        ;0=shorter

circdist:
ca

        lea     sin1024(pc),a1
        lea     4*256(a1),a2
        
        lea     current_tiles(pc),a3
        lea     local+2(pc),a4
        addq.w  #4,(a4)
        moveq   #-16,d7
.lop1
        moveq   #-16,d4
.lop2
        move    d7,d6
        move    d4,d0
        
        muls    d6,d6
        muls    d0,d0

        IFEQ    cacool-1
                
        move    #-578,d5
        add.w   d0,d5
        add.w   d5,d6
        muls    d6,d6   
        asr.l   #8,d6
        asr.l   #2,d6
        add     (a4),d6

        ELSE

        add.l   d0,d6
        sub     (a4),d6
        
        ENDC
        
        and     #$3ff,d6
        move    (a1,d6.w*4),d5
        lsr     #6,d5
        move    (a2,d5.w*4),d0  
        move    (a1,d5.w*4),d1  
        move    d0,d3
        move    d1,d2
        muls    d4,d0
        muls    d4,d1
        muls    d7,d2
        muls    d7,d3
        
        add.l   d0,d2
        sub.l   d1,d3   
        moveq   #16-5-3,d0
        lsr.l   d0,d2
        lsr.l   d0,d3   
        move.w  d2,(a3)+
        move.w  d3,(a3)+
        moveq   #1,d3
        move.w  d3,(a3)+
        move.w  d3,(a3)+

        moveq   #17,d0
        addq    #1,d4
        cmp      d0,d4
        bne.s   .lop2
        addq    #1,d7
        cmp     d0,d7
        bne.s   .lop1

        moveq   #1,d0
        bra     rendertilesshape
cb

;------------------------------------------
;movements
;------------------------------------------
camera1:        ;(750 frames)
        dc.w    2,4
        dc.w    5*2,7
        dc.w    $7fff
.c1     dc.b    0,0,0,0
.c2     dc.b    0,0,0,0
.c3     dc.b    64,64,64,64     
        dc.w    200,400,600,800,$7fff
.c4     dc.b    000,000,050,020,010,20,000
.c5     dc.b    050,050,001,020,021,20,001
.c6     dc.b    065,065,065,065,020,65,20       
        even
        
camera2:        ;(750 frames)
        dc.w    2,4
        dc.w    5*2,7
        dc.w    $7fff
.c1     dc.b    0,0,0,0
.c2     dc.b    0,0,0,0
.c3     dc.b    64,64,64,64     
        dc.w    100,200,400,800,$7fff
.c4     dc.b    000,000,010,020,080,000
.c5     dc.b    050,050,021,010,040,001
.c6     dc.b    065,065,065,070,020,65,20       
        even
        
;-----------------------------------------
;
;create camera
;
; calculates the camera matrix out of 
; position and aiming point
;
; 166 bytes
; 
; gets pointer to movement in a5
;
; returns topleft in d0-d2
;
; S=camera position
; T=aim position
;
; D=T-S
; 
;      | Dz             0                       -Dx     |
; C =  | -Dx*Dy         Dx*Dx+Dy*Dy             -Dy*Dz  |
;      | Dx             Dy                      Dz      |
;      
;-----------------------------------------

cca
createcamerakeyframed

        move.l  a5,a0
        addq    #8,a0
        lea     fullcamera(pc),a2
        moveq   #1,d6
.glop2  
        move.l  a0,a1
        add.w   (a5)+,a0
        moveq   #2,d7
.glop1
        move.b  (a0),d0
        move.b  1(a0),d1
        move.b  2(a0),d2
        move.b  3(a0),d3
        move.w  (a1),d4
        move.w  2(a1),d5
        bsr     findkey
        add.w   (a5),a0
        move.w  d0,(a2)+
        dbf     d7,.glop1
        addq    #2,a5

        dbf     d6,.glop2


createcamera:

        lea     fullcamera(pc),a1
                

        moveq   #15,d4          ;0.15 accuracy
        movem.w (a1)+,d0/d1/d3  ;aimpoint
        sub.w   (a1)+,d0
        sub.w   (a1)+,d1
        sub.w   (a1)+,d3
        move.l  a1,a2           ;a2  = camera
        movem.w d0/d1/d3,2*3*2(a1);z = D
        move.w  d3,(a1)+        ;x.x = Dz
        clr.w   (a1)+           ;x.y = 0
        move.w  d0,d2           ;d2  =  Dx 
        neg.w   d0              ;d0  = -Dx
        move.w  d0,(a1)+        ;x.z = -Dx
        muls.w  d1,d0           ;d0  = -Dx * Dy
        muls.w  d3,d1           ;d3  =  Dy * Dz
        asr.l   d4,d0
        asr.l   d4,d1
        neg.w   d1              ;d1  = -Dy * Dz
        muls.w  d3,d3           ;d3  =  Dz * Dz
        muls.w  d2,d2           ;d2  =  Dx * Dx
        asr.l   d4,d3
        asr.l   d4,d2
        add.l   d3,d2           ;d2  =  Dx * Dx + Dy * Dy
        move.w  d0,(a1)+        ;y.x = -Dx * Dy
        move.w  d2,(a1)+        ;y.y =  Dx * Dx + Dy * Dy
        move.w  d1,(a1)+        ;y.z = -Dy * Dz
        addq    #6,a1
                                ;a1  = cadiv 16

        moveq   #14,d4
        moveq   #2,d7           ;renormalise camera
.lop1
        movem.w (a2),d0/d1/d2
        muls.w  d0,d0
        muls.w  d1,d1
        muls.w  d2,d2
        add.l   d1,d0
        add.l   d2,d0           ;d0 = (x*x+y*y+z*z) << 15

;32 bit isqrt
;d0 input       ;16.16
;d2 out         ;8.8

        moveq   #1,d2
        ror.l   #2,d2
        ;       move.l  #$40000000,d2
                moveq.l #32,d1
.l2n
                move.l  d2,d5
                rol.l   d1,d5
                add.w   d2,d2

                cmp.l   d5,d0
                bcs.b   .no
                addq.w  #1,d2
                sub.l   d5,d0
.no
                subq.w  #2,d1
                bgt.b   .l2n

        movem.w (a2),d0/d1/d3
        lsl.l   d4,d0
        lsl.l   d4,d1
        lsl.l   d4,d3
        divs.w  d2,d0
        divs.w  d2,d1
        divs.w  d2,d3
        movem.w d0/d1/d3,(a2)
        addq    #6,a2
        asr.w   #4,d0
        asr.w   #4,d1
        asr.w   #4,d3
        movem.w d0/d1/d3,(a1)
        addq    #6,a1

        dbf     d7,.lop1        
camerasub
        lea     camera(pc),a1
        movem.w camera_z-camera(a1),d0/d1/d2    ;zx,zy,zz
        sub.w   (a1)+,d0
        sub.w   (a1)+,d1
        sub.w   (a1)+,d2        ;subtract x
        sub.w   (a1)+,d0
        sub.w   (a1)+,d1
        sub.w   (a1)+,d2        ;subtract y     d0-d2 now topleft
                                ;a1 now camera_z
        rts
ccb



;------------------------------------------
;
;cleanbuf
;
;------------------------------------------

cleanbuf:

        lea     chunky(pc),a0
        move    #256*256/4-1,d7
.lop1
        clr.l   (a0)+
        dbf     d7,.lop1
        rts
        
;------------------------------------------
;Plane
;------------------------------------------
plane:
pa
        lea     camera2(pc),a5
        bsr     createcamerakeyframed

        lea     current_tiles(pc),a0
        move.w  d0,a3
        move.w  d1,a4
        move.w  d2,a5
        lea     sin1024(pc),a1  
        lea     sin1024+4*64(pc),a2     
        moveq   #33-1,d7
.olop
        swap    d7
        move.l  a3,d0
        move.l  a4,d1
        move.l  a5,d2
        lea     cadiv16_y(pc),a2
        add.w   (a2)+,a3
        add.w   (a2)+,a4
        add.w   (a2)+,a5
        
        move.w  #33-1,d7
.ilop   
        move.l  #50<<16,d3
        cmp.w   #1024,d2
        bmi.s   .novisi
        divs.w  d2,d3
.nodiv
        moveq   #10,d5
        move    d3,d4
        muls    d1,d3           ;z*t (0.16 * 8.8 )
        muls    d0,d4
        asr.l   d5,d3
        asr.l   d5,d4
        move.w  d3,(a0)+
        move.w  d4,(a0)+

        muls.w  d3,d3
        muls.w  d4,d4
        add.l   d4,d3
        swap    d3
        neg.w   d3
        add.w   #200,d3
        move.w  d3,(a0)+
        addq    #2,a0
        bra.s   .visi
.novisi
        move.w  #-500,4(a0)
        addq    #8,a0

.visi
        lea     cadiv16_x(pc),a2
        add.w   (a2)+,d0
        add.w   (a2)+,d1
        add.w   (a2)+,d2

        dbf     d7,.ilop
        swap    d7              
        dbf     d7,.olop        
        
        moveq   #3,d0
        bra     rendertilesshape
pb
        
;------------------------------------------
;Tunnel 136
;------------------------------------------
tunnel:
ta

        lea     camera1(pc),a5
        bsr     createcamerakeyframed

        lea     current_tiles(pc),a0
        move.w  d0,a3
        move.w  d1,a4
        move.w  d2,a5
        
        moveq   #33-1,d7
.olop
        swap    d7
        
        move.l  a3,d0
        move.l  a4,d1
        move.l  a5,d2
        lea     cadiv16_y(pc),a2
        add.w   (a2)+,a3
        add.w   (a2)+,a4
        add.w   (a2)+,a5
        
        move.w  #33-1,d7
.ilop   
        move.l  d0,d3           ;x
        move.l  d1,d4           ;y
        muls.w  d3,d3           ;x*x
        muls.w  d4,d4           ;y*y
        add.l   d4,d3           ;d3=x*x+y*y     16.16


;32 bit isqrt
;d3 input       ;16.16
;d4 out         ;8.8

        moveq   #1,d4
        ror.l   #2,d4
        ;                move.l  #$40000000,d4
                moveq.l #30,d6
.l2n
                move.l  d4,d5
                rol.l   d6,d5
                add.w   d4,d4

                cmp.l   d5,d3
                bcs.b   .no
                addq.w  #1,d4
                sub.l   d5,d3
.no
                subq.w  #2,d6
                bgt.b   .l2n

        tst.w   d4
        beq.s   .ee
        moveq   #64,d3
        swap    d3
        divu.w  d4,d3           ;d3=t 8.8
.ee     
        moveq   #11,d5
        move    d3,d4
        muls    d2,d3           ;z*t (0.16 * 8.8 )
        muls    d1,d4
        asr.l   d5,d3
        asr.l   d5,d4
        add     blr(pc),d3      
        move.w  d3,(a0)+
        move.w  d4,(a0)+
        moveq   #1,d3
        move.w  d3,(a0)+
        move.w  d3,(a0)+
        lea     cadiv16_x(pc),a2
        add.w   (a2)+,d0
        add.w   (a2)+,d1
        add.w   (a2)+,d2

        dbf     d7,.ilop
        swap    d7              
        dbf     d7,.olop        
        
        moveq   #1,d0
        bra     rendertilesshape
tb



;------------------------------------------
;lochTunnel 136
;------------------------------------------
lochtunnel:
t2a

        bsr     camerasub

        lea     current_tiles(pc),a0
        move.w  d0,a3
        move.w  d1,a4
        move.w  d2,a5
        
        moveq   #33-1,d7
.olop
        swap    d7
        
        move.l  a3,d0
        move.l  a4,d1
        move.l  a5,d2
        lea     cadiv16_y(pc),a2
        add.w   (a2)+,a3
        add.w   (a2)+,a4
        add.w   (a2)+,a5
        
        move.w  #33-1,d7
.ilop   
        move.l  d0,d3           ;x
        move.l  d1,d4           ;y
        muls.w  d3,d3           ;x*x
        muls.w  d4,d4           ;y*y
        add.l   d4,d3           ;d3=x*x+y*y     16.16


;32 bit isqrt
;d3 input       ;16.16
;d4 out         ;8.8

        moveq   #1,d4
        ror.l   #2,d4
        ;                move.l  #$40000000,d4
                moveq.l #30,d6
.l2n
                move.l  d4,d5
                rol.l   d6,d5
                add.w   d4,d4

                cmp.l   d5,d3
                bcs.b   .no
                addq.w  #1,d4
                sub.l   d5,d3
.no
                subq.w  #2,d6
                bgt.b   .l2n

        tst.w   d4
        beq.s   .ee
        moveq   #64,d3
        swap    d3
        divu.w  d4,d3           ;d3=t 8.8
.ee     
        moveq   #11,d5
        move    d3,d4
        muls    d2,d3           ;z*t (0.16 * 8.8 )
        muls    d1,d4
        asr.l   d5,d3
        asr.l   d5,d4
        move.l  d3,d5
        add     blr(pc),d3      
        move.w  d3,(a0)+
        move.w  d4,(a0)+
        lsl.w   #3,d3
        lsl.w   #3,d4
        muls    d3,d3
        muls    d4,d4
        add.l   d4,d3
        swap    d3
        asr.w   #2,d3
        sub.w   globalcount+2(pc),d3
        asr.w   #1,d3
        move.w  d3,(a0)+
        addq    #2,a0
        lea     cadiv16_x(pc),a2
        add.w   (a2)+,d0
        add.w   (a2)+,d1
        add.w   (a2)+,d2

        dbf     d7,.ilop
        swap    d7              
        dbf     d7,.olop        
        
        moveq   #1,d0
        bra     rendertilesshape
t2b
        
;------------------------------------------
;Feedback 118 bytes
;------------------------------------------
feedback:
fa
        lea     sin1024(pc),a1
        move.w  globalcount+2(pc),d0

        lea     chunky(pc),a0
        move.l  a0,a2
        and     #$1ff,d0
        add     d0,a2
        move.w  (a1,d0.w*8),d4
        
        lea     current_tiles(pc),a3
        moveq   #33-1,d7
.lop1
        moveq   #33-1,d6
.lop2
        moveq   #32,d0
        moveq   #32,d1
        sub     d7,d0
        sub     d6,d1
        move    d0,d2
        move    d1,d3
        moveq   #3+5,d5
        lsl     d5,d2
        lsl     d5,d3
        moveq   #16,d5
        sub     d5,d0
        sub     d5,d1
        muls    d4,d0
        muls    d4,d1
        moveq   #16-(3+5),d5
        asr.l   d5,d0
        asr.l   d5,d1
        sub     d0,d3
        add     d1,d2   

        move.w  d3,(a3)+
        move.w  d2,(a3)+
        moveq   #1,d3
        move    d3,(a3)+
        move    d3,(a3)+
        dbf     d6,.lop2
        dbf     d7,.lop1        
        addq.l  #1,d6   ;d6=#$00010000

        lea     (a0,d6.l*2),a1  ;feedbuf
        lea     (a1,d6.l),a3    ;text stone2
        lsr.w   #5,d7   ;copy 32 lines
.glo    
        move.l  (a3)+,(a2)+
        dbf     d7,.glo 
.glo2
        move.b  (a0)+,d6
        add     d6,d3
        lsr     #1,d3
        move.b  d3,(a1)+        

        dbf     d7,.glo2                        
        moveq   #2,d0
        bra.w   rendertilesshape
fb
;-------------------------------------
;
;       rain
;
;-------------------------------------
rain
ra
        lea     regs(pc),a3
        
        move.l  (a3),d2
        bchg    #16,d2
        lea     chunky(pc),a0
        move.l  a0,a1
        move.l  a0,a5
        add.l   #water-chunky,a1
        move.l  a1,a4
        add.l   d2,a4

        moveq   #31,d7
.lop1   
        move.l  4(a3),d4
        ror.l   d4,d4   
        add     d7,d4
        move.l  d4,4(a3)
        moveq   #0,d1
        move.w  d4,d1
        move.b  #32,(a4,d1.l)
        
        dbf     d7,.lop1
        
        
        move.l  a5,a0
        add.l   #text_stone-chunky,a5
                move.l  (a3),d7
                lea     1(a1,d7.l),a2
                eor.w   #1,(a3)
                add.l   (a3),a1
.yo
                move.b  (a1)+,d0
                add.b   -256(a1),d0
                add.b   256(a1),d0
                add.w   (a1),d0
                asr.b   #1,d0
                sub.b   (a2),d0
                smi     d1
                sub.b   d1,d0
                move.b  d0,(a2)+
                spl     d2
                and.b   d2,d0
                move.b  (a5)+,d3
                asr.b   #1,d3
                and.b   #%10111111,d3
                lsl     #2,d0
                add     d3,d0
                move.b  d0,(a0)+
                addq.w  #1,d7
                bne.b   .yo
rb:
        rts
        
last    dc.l    0
;-------------------------------------
;
;textgen
;-------------------------------------
title:
titgenad:       
        lea     titledata(pc),a4

rer
        lea     chunky(pc),a0
        add.w   #60*256+20,a0

        moveq   #12-1,d7
.lop1
        move.l  (a4)+,d1
        moveq   #8,d6
.lop2
        move.l  d1,d3
        moveq   #31,d5
.lop3   
        add.l   d3,d3
        scs     d2
        lsr.b   #1,d2
        moveq   #6,d4
.lop4
        or.b    d2,(a0)+
        dbf     d4,.lop4        
        dbf     d5,.lop3
        add.w   #256-(7*32),a0
        dbf     d6,.lop2        
        dbf     d7,.lop1
        rts


titledata:
;       dc.l    %00000000 00000000 00000000 00000000
;                1       2       3       4

        dc.l    %00111001111101100110111100111110
        dc.l    %01101100001101100110110110110000
        dc.l    %01111100111001100110111100111100
        dc.l    %01101101100001100110110110110000
        dc.l    %01101101111100111100110110111110
        
        dc.l    0,0
        dc.l    %01100011001111100110001100111110
        dc.l    %01100011011000110110001101100000
        dc.l    %01100011011111110110001101111000
        dc.l    %01101011011000110011011001100000
        dc.l    %00111110011000110001110001111110
b

;-------- nonresistend data -------------------------
bitplaneptr:    
        dc.l    0
a7saveglob:
        dc.l    0       
ringbuffer:
        dc.l    0       
a7save:
        dc.l    0       
globalcount
        dc.l    0
globalfast
        dc.l    0       
local:
        dc.l    0       
palette:
        blk.l   256,0
regs:
        blk.l   16,0
current_tiles:
        blk.l   33*33*2
blr     dc.w    0
fullcamera:
aimpoint        dc.w    00,-00,3000
position        dc.w    0,0,0
camera:
camera_x:       dc.w    0,0,0
camera_y:       dc.w    0,0,0   
camera_z:       dc.w    0,0,0

cadiv16:
cadiv16_x:      dc.w    0,0,0
cadiv16_y:      dc.w    0,0,0
cadiv16_z:      dc.w    0,0,0

sin1024:
        blk.l   2048,0  
chunky:
        blk.b   65536
text_stone:
        blk.b   65536
feedbackbuf:
        blk.b   65536   
text_stone2:
        blk.b   65536

        blk.b   256,0
water:  blk.b   2*256*256+10*256,0
c       
        printt  "Current Length:"
        printv  b-a

        
